package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        int stringLength = string.length() ;
        int middle = stringLength/2 ;
        char c = string.charAt(middle);
        return c;
    }

    public static String capitalizeMiddleCharacter(String str) {
//        String cap = str.toUpperCase();
//        System.out.println(cap);
//        int stringLength = str.length();
//        int middle = stringLength/2 ;
//        char c = cap.charAt(middle);
//        return String.valueOf(c);
        return Character.toUpperCase(str.charAt(0)) + str.substring(1);

    }

    public static String lowerCaseMiddleCharacter(String str) {
//        String cap = str.toLowerCase();
//        System.out.println(cap);
//        int stringLength = str.length();
//        int middle = stringLength/2 ;
//        char c = cap.charAt(middle);
//        return String.valueOf(c);

        String test = str;
        test = test.substring(0,2) + test.substring(2,3).toLowerCase()+ test.substring(3);
        return test;
    }

    public static Boolean isIsogram(String str) {
        String[] ary = str.split("");
        Set<String> mySet = new HashSet<String>(Arrays.asList(ary));

        if(str.length() == mySet.size()){
            return true;
        }else {
            return false;
        }
}

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
       // return (str.matches("(.)\\1"));
        return (str.matches(".*(.)\\1.*"));
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        return str.replaceAll("(.)\\1+", "$1");

    }

    public static String invertCasing(String str) {
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if (Character.isUpperCase(c))
            {
                chars[i] = Character.toLowerCase(c);
            }
            else if (Character.isLowerCase(c))
            {
                chars[i] = Character.toUpperCase(c);
            }
        }
        return new String(chars);
    }
}