package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee extends Account implements Worker,Transactable {
    private BankAccount bankAccount;
    private Double numberOfHoursWorkedSoFar = 0.0;
    private Double hourlyWage = 0.0;
    private Double BankAccountBalance = 0.0;
    Double InitialAmount = 0.0;

    public Employee() {
    }

    public Employee(BankAccount bankAccount) {
    }

    public Employee( Worker workerEmployee, Transactable transactableEmployee, Transactable bankAccount) {
        super();
        workerEmployee = workerEmployee;
        transactableEmployee = transactableEmployee;
        bankAccount = bankAccount;
    }

    public BankAccount getBankAccount() {
        return bankAccount;
    }

    public void setBankAccount(BankAccount bankAccount) {
        this.bankAccount = bankAccount;
    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        numberOfHoursWorkedSoFar = numberOfHours;
    }

    @Override
    public Double getHoursWorked() {
        return this.numberOfHoursWorkedSoFar;
    }

    @Override
    public Double getHourlyWage() {
        return this.hourlyWage;
    }

    public void setHourlyWage(Double hourlyWage) {
        this.hourlyWage = hourlyWage;
    }

    @Override
    public Double getMoneyEarned() {
        BankAccountBalance = hourlyWage * numberOfHoursWorkedSoFar;
        return BankAccountBalance;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        BankAccountBalance = amountToIncreaseBy;
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        BankAccountBalance = amountToDecreaseBy;
    }

    @Override
    public Double getBalance() {
        return this.BankAccountBalance;
    }
}
